Installing Upgrading Designing Configuring Deploying Monitoring Administering Troubleshooting Reference JBI Components
Close Print View
Reference: JMS and Java CAPS
 

Classic Java CAPS

Java CAPS Management and Monitoring APIs

Java CAPS JMS Reference

Introduction to JMS

JMS and Java CAPS

Implementing JMS in Java CAPS Projects

Using the JMS OTD in Collaboration Definitions

Using JMS Messages in Collaboration Definitions

Inside the JMS IQ Manager

JMS Messaging Features

Message Delivery Order

Message Producer Priorities

Distributed Transactions

Security

Runtime Management

JMS IQ Manager Database

Database Files

Database Location

Database Configuration and Operation

Message Processing Order

JMS IQ Manager Delivery Modes

JMS Client Delivery Modes

Message Producer Priorities

Message Redelivery and Redirection

Redelivery Options

Specifying Redelivery Options in the JMS IQ Manager

Specifying Redelivery Options in a JMS Client

Enqueued Message Properties

Enqueue Time

Sequence Number

Performance Issues

Throttling Producers

JMS Object Type Definitions

Message Types

JMS Message Properties

JMS Message Header Properties

Additional JMS Message Properties

JMS OTD Methods

createBytesMessage()

createBytesMessage(msg)

createMapMessage()

createMessage()

createMessage(msg)

createStreamMessage()

createTextMessage()

createTextMessage(msg)

getDeliveryMode()

getDestination()

getMessageServerURL()

getPriority()

getTimeToLive()

receive(timeout)

receive(timeout, destination)

receiveNoWait()

receiveNoWait(destination)

requestReply(message)

requestReply(timeout, message)

requestReplyTo(message, destName)

requestReplyTo(timeout, message, destName)

send(message)

send(message, deliveryMode, priority, timeToLive)

sendBytes(payload)

sendBytes(payload, deliveryMode, priority, timeToLive)

sendBytesTo(payload, destination)

sendBytesTo(payload, destination, deliveryMode, priority, timeToLive)

sendText(payload)

sendText(payload, deliveryMode, priority, timeToLive)

sendTextTo(payload, destination)

sendTextTo(payload, destination, deliveryMode, priority, timeToLive)

sendTo(message, destination)

sendTo(message, destination, deliveryMode, priority, timeToLive)

setDeliveryMode(arg0)

setDestination(arg0)

setMessageServerURL(arg0)

setPriority(arg0)

setTimeToLive(arg0)

JMS Message Methods

countMapMessage()

countStreamMessage()

countUserProperty()

getBytesMessage()

getJMSMessageType()

getMapMessage()

getMapMessage(arg0)

getMessageProperties()

getStreamMessage()

getStreamMessage(arg0)

getTextMessage()

getUserProperty()

getUserProperty(arg0)

retrieveBytesFromMessage()

retrieveBytesFromMessage(arg0)

retrieveMapMessage(arg0)

retrieveMapMessageList()

retrieveStringFromMessage()

retrieveStringFromMessage(arg0)

retrieveUserProperty(arg0)

retrieveUserPropertyList()

setBytesMessage(arg0)

setJMSMessageType(arg0)

setStreamMessage(arg0, arg1)

setTextMessage(arg0)

storeMapMessage(arg0, arg1)

storeUserProperty(arg0, arg1)

getTimeToWait()

setTimeToWait(arg0)

JMS Client Configuration

Categories

Consumers

Producers

JMS IQ Manager Runtime Configuration

Accessing the Configuration Properties

Configuration Properties Interface

Stable Storage Page

Segment Properties

Journaling and Expiration Properties

Messaging Behavior Page

Throttling Properties

Special FIFO Mode Properties

Time Dependency Properties

Access Control Page

Security Options

Diagnostics Page

Diagnostic Properties

Miscellaneous Page

Enable Alert Option

JMS Provider Management

Overview of MS Control Utility Features

MS Control Utility Details

Flags and Arguments

Syntax

Using the MS Control Utility

To Change Message Contents

To Create a Backup Archive File

To Access an Archive File

To Set the MS Control Utility Timeout Period

To Shut the Server Down

Command/Response Examples

Message Server Example

Message Destination (Queue) Examples

Message Destination (Topic) Examples

Message Examples

Troubleshooting

Timestamp Errors

WebLogic Server Components

Understanding Sun Master Index Configuration Options (Repository)

Understanding Sun Master Index Processing (Repository)

Understanding the Sun Match Engine

Understanding the Business Rules Method Palette

About Application Adapters

About Communication Adapters

About Database Adapters

About Web Server Adapters

What's New in the Sun TCP/IP HL7 Adapter

Java EE Based Components

Sun Master Data Management Suite Primer

Understanding Sun Master Index Configuration Options

Understanding the Master Index Match Engine

Understanding the Master Index Standardization Engine

United States Patient Solution Using MDM

Australia Patient Solution Using MDM

United Kingdom Patient Solution Using MDM

JMS and Java CAPS

Java Message Service

The Java Message Service is a Java API used for sending and receiving messages. It is vendor-independent, and is used almost universally in enterprise messaging systems such as that included in Java CAPS. JMS provides a standard, currently embodied in the JMS version 1.1 specification, which is an integral part of the Java Enterprise Edition (Java EE) Platform 5. The features of the JMS version 1.1 specification have been widely adopted in the Java CAPS JMS implementation, as described in this document. The use of JMS allows loosely coupled, reliable, asynchronous interactions among Java EE components and legacy systems capable of messaging.

Version 1.1 of the JMS API includes the following features:

Additionally, the Java EE platform’s Enterprise JavaBeans (EJB) container architecture provides the following enhancements the JMS API:

JMS Message Servers

JMS message servers provide the global messaging protocols, such as the routing and delivery of messages, and connection to the JMS database.

By default, Sun Enterprise Service Bus contains the following message server options:

The Sun Java System Message Queue is the current default message server for Java CAPS 6.

The Sun JMS IQ Manager was the default JMS message server implementation for Sun SeeBeyond eGate Integrator, the predecessor to Sun Enterprise Service Bus. This software is installed automatically if you select Complete when installing from the GUI, or as an option if you use any other installation method. The JMS IQ Manager conforms to the Java Message specification 1.1 and supports both topic (publish-and-subscribe) and queue (point-to-point) messaging styles. Inside the JMS IQ Manager includes information about how the JMS IQ Manager processes messages, in concert with the JMS clients. JMS IQ Manager Runtime Configuration provides detailed information about the JMS IQ Manager property options.

JMS Message Destinations

A message destination is a container for stored data, and can follow either the JMS topic or queue model.

Each message destination has at least two JMS Clients associated with it: a producer client at its input, and a consumer client at (each) output. JMS message destinations are discussed in Developing Java CAPS Projects.

JMS Clients

JMS clients provide the local messaging protocols, such as message persistence and delivery semantics, for messages being propagated between Project components. Together with the JMS message server, they constitute a JMS provider.

JMS clients are of two basic types, producers and consumers, or a combination of both. If associated with a queue, these types become queue senders and receivers, respectively. If associated with a topic, they become topic publishers and subscribers, respectively.

JMS client configuration is discussed in JMS Client Configuration.

JMS Object Type Definitions

The JMS Object Type Definition (OTD) acts as a “wrapper” around a message or connection, allowing Collaborations to read from and write to topics or queues. It indicates to the Collaboration which topic or queue it expects to receive messages from or send messages to, and allows you to build the JMS business rules. The JMS OTD and its properties are discussed in JMS Object Type Definitions. JMS OTD methods are described in JMS OTD Methods and JMS Message Methods.

JMS Library File

JMS methods are contained in the JMS library file. In Java CAPS 6, this file is located in the following path:

…\appserver\domains\domain1\lib\com.stc.jms.stcjms.jar